package com.hai.dao;

import com.hai.entity.HighChildOrder;
import com.hai.entity.HighChildOrderExample.Criteria;
import com.hai.entity.HighChildOrderExample.Criterion;
import com.hai.entity.HighChildOrderExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighChildOrderSqlProvider {

    public String countByExample(HighChildOrderExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_child_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighChildOrderExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_child_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighChildOrder record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_child_order");
        
        if (record.getOrderId() != null) {
            sql.VALUES("order_id", "#{orderId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMemId() != null) {
            sql.VALUES("mem_id", "#{memId,jdbcType=BIGINT}");
        }
        
        if (record.getMemName() != null) {
            sql.VALUES("mem_name", "#{memName,jdbcType=VARCHAR}");
        }
        
        if (record.getMemPhone() != null) {
            sql.VALUES("mem_phone", "#{memPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.VALUES("child_order_no", "#{childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreId() != null) {
            sql.VALUES("store_id", "#{storeId,jdbcType=BIGINT}");
        }
        
        if (record.getStoreName() != null) {
            sql.VALUES("store_name", "#{storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreAddress() != null) {
            sql.VALUES("store_address", "#{storeAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsType() != null) {
            sql.VALUES("goods_type", "#{goodsType,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsId() != null) {
            sql.VALUES("goods_id", "#{goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsName() != null) {
            sql.VALUES("goods_name", "#{goodsName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsDesc() != null) {
            sql.VALUES("goods_desc", "#{goodsDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsImg() != null) {
            sql.VALUES("goods_img", "#{goodsImg,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsSpecName() != null) {
            sql.VALUES("goods_spec_name", "#{goodsSpecName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsPrice() != null) {
            sql.VALUES("goods_price", "#{goodsPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGoodsActualPrice() != null) {
            sql.VALUES("goods_actual_price", "#{goodsActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getTotalPrice() != null) {
            sql.VALUES("total_price", "#{totalPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getTotalActualPrice() != null) {
            sql.VALUES("total_actual_price", "#{totalActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getTotalDeductionPrice() != null) {
            sql.VALUES("total_deduction_price", "#{totalDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSaleCount() != null) {
            sql.VALUES("sale_count", "#{saleCount,jdbcType=INTEGER}");
        }
        
        if (record.getSurplusRefundNum() != null) {
            sql.VALUES("surplus_refund_num", "#{surplusRefundNum,jdbcType=INTEGER}");
        }
        
        if (record.getSurplusRefundPrice() != null) {
            sql.VALUES("surplus_refund_price", "#{surplusRefundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSurplusRefundIntegral() != null) {
            sql.VALUES("surplus_refund_integral", "#{surplusRefundIntegral,jdbcType=INTEGER}");
        }
        
        if (record.getChannelOrderNo() != null) {
            sql.VALUES("channel_order_no", "#{channelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGiveawayType() != null) {
            sql.VALUES("giveaway_type", "#{giveawayType,jdbcType=BIT}");
        }
        
        if (record.getChildOrderStatus() != null) {
            sql.VALUES("child_order_status", "#{childOrderStatus,jdbcType=INTEGER}");
        }
        
        if (record.getPraiseStatus() != null) {
            sql.VALUES("praise_status", "#{praiseStatus,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPayTime() != null) {
            sql.VALUES("pay_time", "#{payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.VALUES("finish_time", "#{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundTime() != null) {
            sql.VALUES("refund_time", "#{refundTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundRemarks() != null) {
            sql.VALUES("refund_remarks", "#{refundRemarks,jdbcType=VARCHAR}");
        }
        
        if (record.getCancelTime() != null) {
            sql.VALUES("cancel_time", "#{cancelTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.VALUES("ext_4", "#{ext4,jdbcType=VARCHAR}");
        }
        
        if (record.getExt5() != null) {
            sql.VALUES("ext_5", "#{ext5,jdbcType=VARCHAR}");
        }
        
        if (record.getExt6() != null) {
            sql.VALUES("ext_6", "#{ext6,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighChildOrderExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("order_id");
        sql.SELECT("order_no");
        sql.SELECT("mem_id");
        sql.SELECT("mem_name");
        sql.SELECT("mem_phone");
        sql.SELECT("child_order_no");
        sql.SELECT("store_id");
        sql.SELECT("store_name");
        sql.SELECT("store_address");
        sql.SELECT("goods_type");
        sql.SELECT("goods_id");
        sql.SELECT("goods_name");
        sql.SELECT("goods_desc");
        sql.SELECT("goods_img");
        sql.SELECT("goods_spec_name");
        sql.SELECT("goods_price");
        sql.SELECT("goods_actual_price");
        sql.SELECT("total_price");
        sql.SELECT("total_actual_price");
        sql.SELECT("total_deduction_price");
        sql.SELECT("sale_count");
        sql.SELECT("surplus_refund_num");
        sql.SELECT("surplus_refund_price");
        sql.SELECT("surplus_refund_integral");
        sql.SELECT("channel_order_no");
        sql.SELECT("giveaway_type");
        sql.SELECT("child_order_status");
        sql.SELECT("praise_status");
        sql.SELECT("create_time");
        sql.SELECT("pay_time");
        sql.SELECT("finish_time");
        sql.SELECT("refund_time");
        sql.SELECT("refund_remarks");
        sql.SELECT("cancel_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.SELECT("ext_4");
        sql.SELECT("ext_5");
        sql.SELECT("ext_6");
        sql.FROM("high_child_order");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighChildOrder record = (HighChildOrder) parameter.get("record");
        HighChildOrderExample example = (HighChildOrderExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_child_order");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getOrderId() != null) {
            sql.SET("order_id = #{record.orderId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMemId() != null) {
            sql.SET("mem_id = #{record.memId,jdbcType=BIGINT}");
        }
        
        if (record.getMemName() != null) {
            sql.SET("mem_name = #{record.memName,jdbcType=VARCHAR}");
        }
        
        if (record.getMemPhone() != null) {
            sql.SET("mem_phone = #{record.memPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.SET("child_order_no = #{record.childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreId() != null) {
            sql.SET("store_id = #{record.storeId,jdbcType=BIGINT}");
        }
        
        if (record.getStoreName() != null) {
            sql.SET("store_name = #{record.storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreAddress() != null) {
            sql.SET("store_address = #{record.storeAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsType() != null) {
            sql.SET("goods_type = #{record.goodsType,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsId() != null) {
            sql.SET("goods_id = #{record.goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsName() != null) {
            sql.SET("goods_name = #{record.goodsName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsDesc() != null) {
            sql.SET("goods_desc = #{record.goodsDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsImg() != null) {
            sql.SET("goods_img = #{record.goodsImg,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsSpecName() != null) {
            sql.SET("goods_spec_name = #{record.goodsSpecName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsPrice() != null) {
            sql.SET("goods_price = #{record.goodsPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGoodsActualPrice() != null) {
            sql.SET("goods_actual_price = #{record.goodsActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getTotalPrice() != null) {
            sql.SET("total_price = #{record.totalPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getTotalActualPrice() != null) {
            sql.SET("total_actual_price = #{record.totalActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getTotalDeductionPrice() != null) {
            sql.SET("total_deduction_price = #{record.totalDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSaleCount() != null) {
            sql.SET("sale_count = #{record.saleCount,jdbcType=INTEGER}");
        }
        
        if (record.getSurplusRefundNum() != null) {
            sql.SET("surplus_refund_num = #{record.surplusRefundNum,jdbcType=INTEGER}");
        }
        
        if (record.getSurplusRefundPrice() != null) {
            sql.SET("surplus_refund_price = #{record.surplusRefundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSurplusRefundIntegral() != null) {
            sql.SET("surplus_refund_integral = #{record.surplusRefundIntegral,jdbcType=INTEGER}");
        }
        
        if (record.getChannelOrderNo() != null) {
            sql.SET("channel_order_no = #{record.channelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGiveawayType() != null) {
            sql.SET("giveaway_type = #{record.giveawayType,jdbcType=BIT}");
        }
        
        if (record.getChildOrderStatus() != null) {
            sql.SET("child_order_status = #{record.childOrderStatus,jdbcType=INTEGER}");
        }
        
        if (record.getPraiseStatus() != null) {
            sql.SET("praise_status = #{record.praiseStatus,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPayTime() != null) {
            sql.SET("pay_time = #{record.payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundTime() != null) {
            sql.SET("refund_time = #{record.refundTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundRemarks() != null) {
            sql.SET("refund_remarks = #{record.refundRemarks,jdbcType=VARCHAR}");
        }
        
        if (record.getCancelTime() != null) {
            sql.SET("cancel_time = #{record.cancelTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.SET("ext_4 = #{record.ext4,jdbcType=VARCHAR}");
        }
        
        if (record.getExt5() != null) {
            sql.SET("ext_5 = #{record.ext5,jdbcType=VARCHAR}");
        }
        
        if (record.getExt6() != null) {
            sql.SET("ext_6 = #{record.ext6,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_child_order");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("order_id = #{record.orderId,jdbcType=BIGINT}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("mem_id = #{record.memId,jdbcType=BIGINT}");
        sql.SET("mem_name = #{record.memName,jdbcType=VARCHAR}");
        sql.SET("mem_phone = #{record.memPhone,jdbcType=VARCHAR}");
        sql.SET("child_order_no = #{record.childOrderNo,jdbcType=VARCHAR}");
        sql.SET("store_id = #{record.storeId,jdbcType=BIGINT}");
        sql.SET("store_name = #{record.storeName,jdbcType=VARCHAR}");
        sql.SET("store_address = #{record.storeAddress,jdbcType=VARCHAR}");
        sql.SET("goods_type = #{record.goodsType,jdbcType=INTEGER}");
        sql.SET("goods_id = #{record.goodsId,jdbcType=BIGINT}");
        sql.SET("goods_name = #{record.goodsName,jdbcType=VARCHAR}");
        sql.SET("goods_desc = #{record.goodsDesc,jdbcType=VARCHAR}");
        sql.SET("goods_img = #{record.goodsImg,jdbcType=VARCHAR}");
        sql.SET("goods_spec_name = #{record.goodsSpecName,jdbcType=VARCHAR}");
        sql.SET("goods_price = #{record.goodsPrice,jdbcType=DECIMAL}");
        sql.SET("goods_actual_price = #{record.goodsActualPrice,jdbcType=DECIMAL}");
        sql.SET("total_price = #{record.totalPrice,jdbcType=DECIMAL}");
        sql.SET("total_actual_price = #{record.totalActualPrice,jdbcType=DECIMAL}");
        sql.SET("total_deduction_price = #{record.totalDeductionPrice,jdbcType=DECIMAL}");
        sql.SET("sale_count = #{record.saleCount,jdbcType=INTEGER}");
        sql.SET("surplus_refund_num = #{record.surplusRefundNum,jdbcType=INTEGER}");
        sql.SET("surplus_refund_price = #{record.surplusRefundPrice,jdbcType=DECIMAL}");
        sql.SET("surplus_refund_integral = #{record.surplusRefundIntegral,jdbcType=INTEGER}");
        sql.SET("channel_order_no = #{record.channelOrderNo,jdbcType=VARCHAR}");
        sql.SET("giveaway_type = #{record.giveawayType,jdbcType=BIT}");
        sql.SET("child_order_status = #{record.childOrderStatus,jdbcType=INTEGER}");
        sql.SET("praise_status = #{record.praiseStatus,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("pay_time = #{record.payTime,jdbcType=TIMESTAMP}");
        sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        sql.SET("refund_time = #{record.refundTime,jdbcType=TIMESTAMP}");
        sql.SET("refund_remarks = #{record.refundRemarks,jdbcType=VARCHAR}");
        sql.SET("cancel_time = #{record.cancelTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        sql.SET("ext_4 = #{record.ext4,jdbcType=VARCHAR}");
        sql.SET("ext_5 = #{record.ext5,jdbcType=VARCHAR}");
        sql.SET("ext_6 = #{record.ext6,jdbcType=VARCHAR}");
        
        HighChildOrderExample example = (HighChildOrderExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighChildOrder record) {
        SQL sql = new SQL();
        sql.UPDATE("high_child_order");
        
        if (record.getOrderId() != null) {
            sql.SET("order_id = #{orderId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMemId() != null) {
            sql.SET("mem_id = #{memId,jdbcType=BIGINT}");
        }
        
        if (record.getMemName() != null) {
            sql.SET("mem_name = #{memName,jdbcType=VARCHAR}");
        }
        
        if (record.getMemPhone() != null) {
            sql.SET("mem_phone = #{memPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.SET("child_order_no = #{childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreId() != null) {
            sql.SET("store_id = #{storeId,jdbcType=BIGINT}");
        }
        
        if (record.getStoreName() != null) {
            sql.SET("store_name = #{storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreAddress() != null) {
            sql.SET("store_address = #{storeAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsType() != null) {
            sql.SET("goods_type = #{goodsType,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsId() != null) {
            sql.SET("goods_id = #{goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsName() != null) {
            sql.SET("goods_name = #{goodsName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsDesc() != null) {
            sql.SET("goods_desc = #{goodsDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsImg() != null) {
            sql.SET("goods_img = #{goodsImg,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsSpecName() != null) {
            sql.SET("goods_spec_name = #{goodsSpecName,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsPrice() != null) {
            sql.SET("goods_price = #{goodsPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getGoodsActualPrice() != null) {
            sql.SET("goods_actual_price = #{goodsActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getTotalPrice() != null) {
            sql.SET("total_price = #{totalPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getTotalActualPrice() != null) {
            sql.SET("total_actual_price = #{totalActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getTotalDeductionPrice() != null) {
            sql.SET("total_deduction_price = #{totalDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSaleCount() != null) {
            sql.SET("sale_count = #{saleCount,jdbcType=INTEGER}");
        }
        
        if (record.getSurplusRefundNum() != null) {
            sql.SET("surplus_refund_num = #{surplusRefundNum,jdbcType=INTEGER}");
        }
        
        if (record.getSurplusRefundPrice() != null) {
            sql.SET("surplus_refund_price = #{surplusRefundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSurplusRefundIntegral() != null) {
            sql.SET("surplus_refund_integral = #{surplusRefundIntegral,jdbcType=INTEGER}");
        }
        
        if (record.getChannelOrderNo() != null) {
            sql.SET("channel_order_no = #{channelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGiveawayType() != null) {
            sql.SET("giveaway_type = #{giveawayType,jdbcType=BIT}");
        }
        
        if (record.getChildOrderStatus() != null) {
            sql.SET("child_order_status = #{childOrderStatus,jdbcType=INTEGER}");
        }
        
        if (record.getPraiseStatus() != null) {
            sql.SET("praise_status = #{praiseStatus,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPayTime() != null) {
            sql.SET("pay_time = #{payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundTime() != null) {
            sql.SET("refund_time = #{refundTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRefundRemarks() != null) {
            sql.SET("refund_remarks = #{refundRemarks,jdbcType=VARCHAR}");
        }
        
        if (record.getCancelTime() != null) {
            sql.SET("cancel_time = #{cancelTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.SET("ext_4 = #{ext4,jdbcType=VARCHAR}");
        }
        
        if (record.getExt5() != null) {
            sql.SET("ext_5 = #{ext5,jdbcType=VARCHAR}");
        }
        
        if (record.getExt6() != null) {
            sql.SET("ext_6 = #{ext6,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighChildOrderExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}