package com.hai.dao;

import com.hai.entity.HighDiscountUserRel;
import com.hai.entity.HighDiscountUserRelExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighDiscountUserRelMapper extends HighDiscountUserRelMapperExt {
    @SelectProvider(type=HighDiscountUserRelSqlProvider.class, method="countByExample")
    long countByExample(HighDiscountUserRelExample example);

    @DeleteProvider(type=HighDiscountUserRelSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighDiscountUserRelExample example);

    @Delete({
        "delete from high_discount_user_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_discount_user_rel (discount_company_id, discount_id, ",
        "discount_name, discount_img, ",
        "discount_using_range, discount_use_scope, ",
        "discount_type, discount_condition, ",
        "discount_price, agent_id, ",
        "discount_agent_code_id, user_id, ",
        "`status`, use_time, ",
        "create_time, use_end_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{discountCompanyId,jdbcType=BIGINT}, #{discountId,jdbcType=BIGINT}, ",
        "#{discountName,jdbcType=VARCHAR}, #{discountImg,jdbcType=VARCHAR}, ",
        "#{discountUsingRange,jdbcType=INTEGER}, #{discountUseScope,jdbcType=INTEGER}, ",
        "#{discountType,jdbcType=INTEGER}, #{discountCondition,jdbcType=DECIMAL}, ",
        "#{discountPrice,jdbcType=DECIMAL}, #{agentId,jdbcType=BIGINT}, ",
        "#{discountAgentCodeId,jdbcType=BIGINT}, #{userId,jdbcType=BIGINT}, ",
        "#{status,jdbcType=INTEGER}, #{useTime,jdbcType=TIMESTAMP}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{useEndTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighDiscountUserRel record);

    @InsertProvider(type=HighDiscountUserRelSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighDiscountUserRel record);

    @SelectProvider(type=HighDiscountUserRelSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_company_id", property="discountCompanyId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_name", property="discountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_img", property="discountImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_using_range", property="discountUsingRange", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_use_scope", property="discountUseScope", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_type", property="discountType", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_condition", property="discountCondition", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_agent_code_id", property="discountAgentCodeId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="use_time", property="useTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="use_end_time", property="useEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighDiscountUserRel> selectByExample(HighDiscountUserRelExample example);

    @Select({
        "select",
        "id, discount_company_id, discount_id, discount_name, discount_img, discount_using_range, ",
        "discount_use_scope, discount_type, discount_condition, discount_price, agent_id, ",
        "discount_agent_code_id, user_id, `status`, use_time, create_time, use_end_time, ",
        "ext_1, ext_2, ext_3",
        "from high_discount_user_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_company_id", property="discountCompanyId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_name", property="discountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_img", property="discountImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_using_range", property="discountUsingRange", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_use_scope", property="discountUseScope", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_type", property="discountType", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_condition", property="discountCondition", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_agent_code_id", property="discountAgentCodeId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="use_time", property="useTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="use_end_time", property="useEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighDiscountUserRel selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighDiscountUserRelSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighDiscountUserRel record, @Param("example") HighDiscountUserRelExample example);

    @UpdateProvider(type=HighDiscountUserRelSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighDiscountUserRel record, @Param("example") HighDiscountUserRelExample example);

    @UpdateProvider(type=HighDiscountUserRelSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighDiscountUserRel record);

    @Update({
        "update high_discount_user_rel",
        "set discount_company_id = #{discountCompanyId,jdbcType=BIGINT},",
          "discount_id = #{discountId,jdbcType=BIGINT},",
          "discount_name = #{discountName,jdbcType=VARCHAR},",
          "discount_img = #{discountImg,jdbcType=VARCHAR},",
          "discount_using_range = #{discountUsingRange,jdbcType=INTEGER},",
          "discount_use_scope = #{discountUseScope,jdbcType=INTEGER},",
          "discount_type = #{discountType,jdbcType=INTEGER},",
          "discount_condition = #{discountCondition,jdbcType=DECIMAL},",
          "discount_price = #{discountPrice,jdbcType=DECIMAL},",
          "agent_id = #{agentId,jdbcType=BIGINT},",
          "discount_agent_code_id = #{discountAgentCodeId,jdbcType=BIGINT},",
          "user_id = #{userId,jdbcType=BIGINT},",
          "`status` = #{status,jdbcType=INTEGER},",
          "use_time = #{useTime,jdbcType=TIMESTAMP},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "use_end_time = #{useEndTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighDiscountUserRel record);
}