package com.hai.service;

import com.alibaba.fastjson.JSONObject;
import com.hai.entity.BsIntegralRebate;
import com.hai.entity.BsRequestRecord;

import java.util.List;
import java.util.Map;

/**
 * @serviceName BsIntegralRebateService.java
 * @author Sum1Dream
 * @version 1.0.0
 * @Description // 积分返利配置
 * @createTime 11:31 2022/8/2
 **/
public interface BsIntegralRebateService {

    /**
    * @Author Sum1Dream
    * @name findIntegralRebateByMap.java
    * @Description // 查询积分配置
    * @Date 11:32 2022/8/2
    * @Param [java.util.Map<java.lang.String,java.lang.Object>]
    * @return com.hai.entity.BsIntegralRebate
    */
    BsIntegralRebate findIntegralRebateByMap(Map<String, Object> map);

    /**
    * @Author Sum1Dream
    * @name findIntegralRebateById.java
    * @Description // 根据ID查询详情
    * @Date 14:03 2022/8/2
    * @Param [java.lang.Long]
    * @return com.hai.entity.BsIntegralRebate
    */
    BsIntegralRebate findIntegralRebateById(Long id);

    /**
    * @Author Sum1Dream
    * @name getIntegralRebateByList.java
    * @Description //
    * @Date 14:04 2022/8/2
    * @Param [java.util.Map<java.lang.String,java.lang.Object>]
    * @return java.util.List<com.hai.entity.BsIntegralRebate>
    */
    List<BsIntegralRebate> getIntegralRebateByList(Map<String, Object> map);


    /**
    * @Author Sum1Dream
    * @name insertIntegralRebate.java
    * @Description // 插入请求记录
    * @Date 15:31 2022/8/2
    * @Param [com.hai.entity.BsIntegralRebate]
    * @return void
    */
    void insertIntegralRebate(BsIntegralRebate bsIntegralRebate);

    /**
    * @Author Sum1Dream
    * @name updateIntegralRebate.java
    * @Description // 更新请求记录
    * @Date 15:31 2022/8/2
    * @Param [com.hai.entity.BsIntegralRebate]
    * @return void
    */
    void updateIntegralRebate(BsIntegralRebate bsIntegralRebate);


    /**
     * @Author Sum1Dream
     * @Description //删除 Administrator
     * @Date 17:31 2021/6/13
     * @Param [id]
     * @return void
     **/
    void deleteIntegralRebate(Long id);

    /**
     * @Author Sum1Dream
     * @Name integralRebate
     * @Description // 订单积分返利
     * @Date 11:32 2022/9/1
     * @Param [object]
     * @Return void
     */
    void integralRebate(JSONObject object);

    /**
     * @Author Sum1Dream
     * @Name integralRechargeRebate
     * @Description // 话费订单返利
     * @Date 11:33 2022/9/1
     * @Param [object]
     * @Return void
     */
    void integralRechargeRebate(JSONObject object);

}
